/***********************************************************************/
/*                                                                     */
/*  FILE        :proto.h                                                 */
/*  DATE        :26.12.08                                              */
/*  COPYRIGHT   :Copyright (C) 2008 by Thomas Hochgtz                 */
/*                                                                     */
/***********************************************************************/
     
#ifndef _PROTO_H_
#define _PROTO_H_     

// LED_0  power on
// LED_1  device select
// LED_2  device is sender
// LED_3  error

//=============== FUNCTIONS =============
void					InitProto();
void					ResetProto();
void					Loop();
unsigned char			ReceiveUART( unsigned char waitData, unsigned char* isData=0 );
void					SwitchDirection( unsigned char sender );

void					LoopDebug();
void					CheckDebug();
void					LoopNone();


enum PC_COMMANDS
{
	PC_RECEIVED,
	PC_DATA,
	
	PC_DEVICE_MODE,
	PC_COMPUTER_MODE,
	PC_DEBUG_MODE,
	
	PC_RESET,
	PC_STATUS,

	PC_EOI,
	PC_ERROR,

	PC_ATN_ON,
	PC_ATN_OFF,
	PC_RST_ON,
	PC_RST_OFF,
	PC_CLK_ON,
	PC_CLK_OFF,
	PC_DTA_ON,
	PC_DTA_OFF,

	PC_DEV_ADDR,
	PC_TIMEOUT,
};



enum PC_ERRORS
{
	PCERR_NONE,
	PCERR_FRAME,
	PCERR_DEVICE_NOT_PRESENT,
	
	PCERR_TIMEOUT,
	PCERR_RECV_BYTE,
	PCERR_READY_TO_SEND,
	PCERR_READY_TO_RECV,
	PCERR_ACK_EOI,
	PCERR_ACK_FRAME,
	PCERR_TURN,
};


typedef void (*TODO_FUNC)();
enum TODOFUNCS
{
	TODOFUNC_DEV_RECEIVER,
	TODOFUNC_COM_RECEIVER,
	TODOFUNC_DEV_SENDER,
	TODOFUNC_COM_SENDER,
	TODOFUNC_DEV_CHECK,
	TODOFUNC_COM_CHECK,
	TODOFUNC_DEV_NONE,
	TODOFUNC_COM_NONE,
	TODOFUNC_DEBUG,
	TODOFUNC_DEBUG_CHECK,
	TODOFUNC_MAX,
};
static	TODO_FUNC	aFuncs[TODOFUNC_MAX];


typedef struct tSettings
{
	unsigned char	dev_addr;
	unsigned char	computer;
	unsigned char	revert;
	unsigned char	dorevert;
	unsigned char	select;
	unsigned char	EOI;
	unsigned char	SET_EOI;
	unsigned char	SET_LAST;
	unsigned char	ATN;
	unsigned char	ATNcount;
	unsigned char	data;
	unsigned char	data_send;
	unsigned char	error;
	unsigned char	debug;
	TODO_FUNC		func;
	TODO_FUNC		check;
} settings;

extern struct tSettings		sett;




#endif



